#include "framebuffer.h"

#include <iostream>
#include <GLFW/glfw3.h>

FrameBuffer::~FrameBuffer(){
    glBindFramebuffer(GL_FRAMEBUFFER, 0);
    glDeleteFramebuffers(1, &fbo_);
}


void FrameBuffer::Initialize(GLuint texture){
    GLuint fbo_status;

    // Obiekt buforu ramki
    glGenFramebuffers(1, &fbo_);
    glBindFramebuffer(GL_FRAMEBUFFER, fbo_);

    glDrawBuffer(GL_NONE);
    glReadBuffer(GL_NONE);


    glFramebufferTexture2D(GL_FRAMEBUFFER, GL_DEPTH_ATTACHMENT, GL_TEXTURE_2D, texture, 0);

    // sprawdzamy FBO
    if ((fbo_status = glCheckFramebufferStatus(GL_FRAMEBUFFER)) != GL_FRAMEBUFFER_COMPLETE){
      std::cerr << "glCheckFramebufferStatus error "<< fbo_status<<std::endl;
      glfwTerminate();
      exit(EXIT_FAILURE);
    }

    glBindFramebuffer(GL_FRAMEBUFFER, 0);
}
