#ifndef PLANE_H
#define PLANE_H

#include "materialmodel.h"
#include "lightablemodel.h"
#include "movablemodel.h"
#include "indexmodel.h"
#include "texturemodel.h"
#include "matma.h"
#include "vertices.h"
#include "lightprogram.h"
#include "shadowprogram.h"

class Plane :
        public IndexModel,
        public LightableModel,
        public MovableModel,
        public TextureModel,
        public MaterialModel{
public:
    void Initialize(GLuint m, GLuint n);
    void Draw(const LightProgram & program) const;
    void DrawShadow(const ShadowProgram & program) const;
private:
    GLuint n_; // mesh parameter
    GLuint m_; // mesh parameter

};

#endif // PLANE_H
