#include "shadowprogram.h"

#include <cmath>

void ShadowProgram::SetModelMatrix(const Mat4 & matrix) const {
    glUniformMatrix4fv(model_matrix_location_, 1, GL_FALSE, matrix);
}

void ShadowProgram::Initialize(const char *vertex_shader_file, const char *fragment_shader_file){
    BaseProgram::Initialize(vertex_shader_file, fragment_shader_file);
    model_matrix_location_ = GetUniformLocationOrDie("model_matrix");
    light_tranform_matrix_location_ = GetUniformLocationOrDie("light_transform_matrix");
}


void ShadowProgram::SetSunLightTransform(const SunLight &light){
    Mat4 light_tranform_matrix;
    light_tranform_matrix = Mat4::CreateSunLightTransformMatrix(light);
    glUniformMatrix4fv(light_tranform_matrix_location_, 1, GL_FALSE, light_tranform_matrix);
    glUseProgram(0);
}
