#include <cmath>

#include "shadowsunlightprogram.h"

void ShadowSunLightProgram::Initialize(
        const char *vertex_shader_file,
        const char *fragment_shader_file){
    SunLightProgram::Initialize(vertex_shader_file, fragment_shader_file);
    depth_texture_unit_location_= GetUniformLocationOrDie("depth_texture");
    light_transform_matrix_location_= GetUniformLocationOrDie("light_transform_matrix");
}

void ShadowSunLightProgram::SetDepthTextureUnit(GLint t){
    glUniform1i(depth_texture_unit_location_, t);
}

void ShadowSunLightProgram::SetSunLightTransform(const SunLight & light){
    Mat4 light_transform_matrix;
    light_transform_matrix = Mat4::CreateBiasSunLightTransformMatrix(light);

    glUniformMatrix4fv(light_transform_matrix_location_, 1, GL_FALSE, light_transform_matrix);
}

